Index: trunk/i18n/uk.ts
===================================================================
--- trunk/i18n/uk.ts	(revision 53)
+++ trunk/i18n/uk.ts	(revision 54)
@@ -309,339 +335,261 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="328"/>
-        <location filename="../ui/mainwindow.ui" line="351"/>
-        <source>Solution S&amp;teps</source>
-        <translation>&amp;Хід розв&apos;язку</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="342"/>
-        <location filename="../ui/mainwindow.ui" line="365"/>
-        <source>Solution &amp;Graph</source>
-        <translation>&amp;Граф розв&apos;язку</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="359"/>
+        <location filename="../ui/mainwindow.ui" line="418"/>
         <source>Solution...</source>
         <translation>Розв&apos;язок...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="449"/>
-        <location filename="../ui/mainwindow.ui" line="469"/>
+        <location filename="../ui/mainwindow.ui" line="511"/>
         <source>Context &amp;Help</source>
         <translation>&amp;Контекстна допомога</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="540"/>
-        <location filename="../ui/mainwindow.ui" line="556"/>
+        <location filename="../ui/mainwindow.ui" line="598"/>
         <source>&amp;Save</source>
         <translation>&amp;Зберегти</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="267"/>
-        <location filename="../ui/mainwindow.ui" line="255"/>
+        <location filename="../ui/mainwindow.ui" line="306"/>
         <source>&amp;Settings</source>
         <translation>&amp;Налагодження</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="17"/>
-        <location filename="../ui/mainwindow.ui" line="14"/>
-        <source>Travelling salesman problem[*]</source>
-        <translation>Задача комівояжера[*]</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="293"/>
-        <location filename="../ui/mainwindow.ui" line="281"/>
+        <location filename="../ui/mainwindow.ui" line="332"/>
         <source>&amp;Help</source>
         <translation>&amp;Допомога</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="331"/>
-        <location filename="../ui/mainwindow.ui" line="354"/>
-        <source>Save solution steps</source>
-        <translation>Зберегти хід розв&apos;язку</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="334"/>
-        <location filename="../ui/mainwindow.ui" line="357"/>
-        <source>Save solution steps only</source>
-        <translation>Зберегти тільки хід розв&apos;язку</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="345"/>
-        <location filename="../ui/mainwindow.ui" line="368"/>
-        <source>Save solution graph</source>
-        <translation>Зберегти граф розв&apos;язку</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="348"/>
-        <location filename="../ui/mainwindow.ui" line="371"/>
-        <source>Save solution graph only</source>
-        <translation>Зберегти тільки граф розв&apos;язку</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="362"/>
-        <location filename="../ui/mainwindow.ui" line="382"/>
+        <location filename="../ui/mainwindow.ui" line="421"/>
         <source>Save solution</source>
         <translation>Зберегти розв&apos;язок</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="365"/>
-        <location filename="../ui/mainwindow.ui" line="385"/>
-        <source>Save solution steps and graph</source>
-        <translation>Зберегти хід та граф розв&apos;язку</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="374"/>
-        <location filename="../ui/mainwindow.ui" line="394"/>
+        <location filename="../ui/mainwindow.ui" line="433"/>
         <source>&amp;New</source>
         <translation>&amp;Створити</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="377"/>
-        <location filename="../ui/mainwindow.ui" line="397"/>
+        <location filename="../ui/mainwindow.ui" line="436"/>
         <source>New</source>
         <translation>Створити</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="380"/>
-        <location filename="../ui/mainwindow.ui" line="400"/>
+        <location filename="../ui/mainwindow.ui" line="439"/>
         <source>New task</source>
         <translation>Нова задача</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="383"/>
-        <location filename="../ui/mainwindow.ui" line="403"/>
+        <location filename="../ui/mainwindow.ui" line="442"/>
         <source>Create new task</source>
         <translation>Створити нову задачу</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="395"/>
-        <location filename="../ui/mainwindow.ui" line="415"/>
+        <location filename="../ui/mainwindow.ui" line="454"/>
         <source>&amp;Open...</source>
         <translation>&amp;Відкрити...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="398"/>
-        <location filename="../ui/mainwindow.ui" line="418"/>
+        <location filename="../ui/mainwindow.ui" line="457"/>
         <source>Open...</source>
         <translation>Відкрити...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="401"/>
-        <location filename="../ui/mainwindow.ui" line="421"/>
+        <location filename="../ui/mainwindow.ui" line="460"/>
         <source>Open task</source>
         <translation>Відкрити умову</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="404"/>
-        <location filename="../ui/mainwindow.ui" line="424"/>
+        <location filename="../ui/mainwindow.ui" line="463"/>
         <source>Open saved task</source>
         <translation>Відкрити збережену умову</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="407"/>
-        <location filename="../ui/mainwindow.ui" line="427"/>
+        <location filename="../ui/mainwindow.ui" line="466"/>
         <source>Ctrl+O</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="416"/>
-        <location filename="../ui/mainwindow.ui" line="436"/>
+        <location filename="../ui/mainwindow.ui" line="475"/>
         <source>&amp;Preferences...</source>
         <translation>&amp;Параметри...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="419"/>
-        <location filename="../ui/mainwindow.ui" line="439"/>
+        <location filename="../ui/mainwindow.ui" line="478"/>
         <source>Preferences...</source>
         <translation>Параметри...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="422"/>
-        <location filename="../ui/mainwindow.ui" line="442"/>
+        <location filename="../ui/mainwindow.ui" line="481"/>
         <source>Application preferences</source>
         <translation>Параметри додатку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="434"/>
-        <location filename="../ui/mainwindow.ui" line="454"/>
+        <location filename="../ui/mainwindow.ui" line="493"/>
         <source>&amp;Contents</source>
         <translation>&amp;Зміст</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="437"/>
-        <location filename="../ui/mainwindow.ui" line="457"/>
+        <location filename="../ui/mainwindow.ui" line="496"/>
         <source>Open help contents</source>
         <translation>Відкрити зміст допомоги</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="452"/>
-        <location filename="../ui/mainwindow.ui" line="472"/>
+        <location filename="../ui/mainwindow.ui" line="499"/>
+        <source>Ctrl+F1</source>
+        <translation></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="514"/>
         <source>Open context help</source>
         <translation>Відкрити контекстну допомогу</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="461"/>
-        <location filename="../ui/mainwindow.ui" line="481"/>
+        <location filename="../ui/mainwindow.ui" line="517"/>
+        <source>F1</source>
+        <translation></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="526"/>
         <source>&amp;About...</source>
         <translation>&amp;Про...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="464"/>
-        <location filename="../ui/mainwindow.ui" line="484"/>
+        <location filename="../ui/mainwindow.ui" line="529"/>
         <source>About...</source>
         <translation>Про...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="467"/>
-        <location filename="../ui/mainwindow.ui" line="487"/>
+        <location filename="../ui/mainwindow.ui" line="532"/>
         <source>About application</source>
         <translation>Про додаток</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="476"/>
-        <location filename="../ui/mainwindow.ui" line="496"/>
+        <location filename="../ui/mainwindow.ui" line="541"/>
         <source>E&amp;xit</source>
         <translation>В&amp;ихід</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="479"/>
-        <location filename="../ui/mainwindow.ui" line="499"/>
+        <location filename="../ui/mainwindow.ui" line="544"/>
         <source>Exit application</source>
         <translation>Вийти з додатку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="488"/>
-        <location filename="../ui/mainwindow.ui" line="504"/>
+        <location filename="../ui/mainwindow.ui" line="549"/>
         <source>&amp;Task...</source>
         <translation>&amp;Умову...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="491"/>
-        <location filename="../ui/mainwindow.ui" line="507"/>
+        <location filename="../ui/mainwindow.ui" line="552"/>
         <source>Task...</source>
         <translation>Умову...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="494"/>
-        <location filename="../ui/mainwindow.ce.ui" line="543"/>
-        <location filename="../ui/mainwindow.ui" line="510"/>
-        <location filename="../ui/mainwindow.ui" line="562"/>
+        <location filename="../ui/mainwindow.ui" line="555"/>
+        <location filename="../ui/mainwindow.ui" line="604"/>
         <source>Save task</source>
         <translation>Зберегти умову</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="497"/>
-        <location filename="../ui/mainwindow.ui" line="513"/>
+        <location filename="../ui/mainwindow.ui" line="558"/>
         <source>Save task to file</source>
         <translation>Зберегти умову задачі у файл</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="511"/>
-        <location filename="../ui/mainwindow.ui" line="527"/>
+        <location filename="../ui/mainwindow.ui" line="569"/>
         <source>&amp;Autodetect</source>
         <translation>&amp;Автовизначення</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="528"/>
-        <source>English</source>
-        <translation>Англійська</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="546"/>
-        <location filename="../ui/mainwindow.ui" line="565"/>
+        <location filename="../ui/mainwindow.ui" line="607"/>
         <source>Save current task</source>
         <translation>Зберегти поточну умову</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="555"/>
-        <location filename="../ui/mainwindow.ui" line="574"/>
+        <location filename="../ui/mainwindow.ui" line="619"/>
         <source>About &amp;Qt...</source>
         <translation>Про &amp;Qt...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="558"/>
-        <location filename="../ui/mainwindow.ui" line="577"/>
+        <location filename="../ui/mainwindow.ui" line="622"/>
         <source>About Qt...</source>
         <translation>Про Qt...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="561"/>
-        <source>About Qt</source>
-        <translation>Про Qt</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="564"/>
-        <location filename="../ui/mainwindow.ui" line="580"/>
+        <location filename="../ui/mainwindow.ui" line="625"/>
         <source>About Qt library</source>
         <translation>Про бібліотеку Qt</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="146"/>
-        <location filename="../src/mainwindow.cpp" line="492"/>
-        <location filename="../src/mainwindow.cpp" line="501"/>
+        <location filename="../src/mainwindow.cpp" line="540"/>
+        <location filename="../src/mainwindow.cpp" line="549"/>
         <source>Language change</source>
         <translation>Зміна мови</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="146"/>
+        <location filename="../src/mainwindow.cpp" line="162"/>
         <source>Unable to load translation language.</source>
         <translation>Неможливо завантажити переклад.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="170"/>
+        <location filename="../src/mainwindow.cpp" line="186"/>
+        <location filename="../ui/mainwindow.ui" line="14"/>
         <source>Travelling Salesman Problem</source>
         <translation>Задача комівояжера</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="192"/>
+        <location filename="../src/mainwindow.cpp" line="204"/>
         <source>Unsaved Changes</source>
         <translation>Незбережені зміни</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="224"/>
+        <location filename="../src/mainwindow.cpp" line="236"/>
         <source>All Supported Formats</source>
         <translation>Усі підтримувані формати</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="227"/>
-        <location filename="../src/mainwindow.cpp" line="267"/>
-        <location filename="../src/mainwindow.cpp" line="296"/>
+        <location filename="../src/mainwindow.cpp" line="239"/>
+        <location filename="../src/mainwindow.cpp" line="289"/>
+        <location filename="../src/mainwindow.cpp" line="323"/>
         <source>All Files</source>
         <translation>Усі файли</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="225"/>
-        <location filename="../src/mainwindow.cpp" line="226"/>
+        <location filename="../src/mainwindow.cpp" line="237"/>
+        <location filename="../src/mainwindow.cpp" line="238"/>
         <source>%1 Task Files</source>
         <translation>Файли умов %1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="192"/>
+        <location filename="../src/mainwindow.cpp" line="162"/>
+        <source>Language Change</source>
+        <translation>Зміна мови</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="204"/>
         <source>Would you like to save changes in current task?</source>
         <translation>Бажаете зберегти зміни у поточній задачі?</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="263"/>
+        <location filename="../src/mainwindow.cpp" line="285"/>
         <source>HTML Files</source>
         <translation>Файли HTML</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="265"/>
+        <location filename="../src/mainwindow.cpp" line="287"/>
         <source>OpenDocument Files</source>
         <translation>Файли OpenDocument</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="295"/>
+        <location filename="../src/mainwindow.cpp" line="322"/>
         <source>%1 Task File</source>
         <translation>Файл умови %1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="326"/>
+        <location filename="../src/mainwindow.cpp" line="353"/>
         <source>Settings Changed</source>
         <translation>Параметри змінено</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="326"/>
+        <location filename="../src/mainwindow.cpp" line="353"/>
         <source>You have changed color settings.
 Do you wish to apply them to current solution text?</source>
@@ -650,56 +598,56 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="390"/>
+        <location filename="../src/mainwindow.cpp" line="438"/>
         <source>Data error</source>
         <translation>Помилка у даних</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="390"/>
+        <location filename="../src/mainwindow.cpp" line="438"/>
         <source>Error in cell [Row %1; Column %2]: Invalid data format.</source>
         <translation>Помилка у комірці  [Рядок %1; Колонка %2]: Невірний формат даних.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="403"/>
+        <location filename="../src/mainwindow.cpp" line="451"/>
         <source>Variant #%1</source>
         <translation>Варіант №%1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="404"/>
+        <location filename="../src/mainwindow.cpp" line="452"/>
         <source>Task:</source>
         <translation>Умова:</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="407"/>
-        <location filename="../src/mainwindow.cpp" line="433"/>
+        <location filename="../src/mainwindow.cpp" line="455"/>
+        <location filename="../src/mainwindow.cpp" line="481"/>
         <source>Solution of Variant #%1 task</source>
         <translation>Розв&apos;язок варіанту №%1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="414"/>
+        <location filename="../src/mainwindow.cpp" line="462"/>
         <source>Step #%1</source>
         <translation>Крок №%1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="417"/>
+        <location filename="../src/mainwindow.cpp" line="465"/>
         <source>This step has alternate candidates for branching.</source>
         <translation>У цьому кроці є альтернативні кандидати на розгалудження.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="429"/>
+        <location filename="../src/mainwindow.cpp" line="477"/>
         <source>Optimal path:</source>
         <translation>Оптимальний шлях:</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="431"/>
+        <location filename="../src/mainwindow.cpp" line="479"/>
         <source>The price is &lt;b&gt;%1&lt;/b&gt; units.</source>
         <translation>Вартість - &lt;b&gt;%1&lt;/b&gt; одиниць.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="492"/>
+        <location filename="../src/mainwindow.cpp" line="540"/>
         <source>Language will be autodetected on next application start.</source>
         <translation>Мову буде автоматично визначено при наступному запуску додатку.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="501"/>
+        <location filename="../src/mainwindow.cpp" line="549"/>
         <source>You have language autodetection turned on.
 It needs to be off.
@@ -710,6 +658,7 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="506"/>
-        <location filename="../src/mainwindow.h" line="76"/>
+        <location filename="../src/mainwindow.h" line="78"/>
+        <location filename="../src/mainwindow.cpp" line="263"/>
+        <location filename="../src/mainwindow.cpp" line="554"/>
         <source>Untitled</source>
         <translation>Без імені</translation>
Index: trunk/src/globals.h
===================================================================
--- trunk/src/globals.h	(revision 53)
+++ trunk/src/globals.h	(revision 54)
@@ -31,5 +31,5 @@
 // Version info
 #include "version.h"
-// OS detection
+// OS and ARCH detection
 #include "os.h"
 
@@ -58,5 +58,5 @@
 
 // Maximum available number of cities
-#define MAX_NUM_CITIES 20
+#define MAX_NUM_CITIES 30
 // This value means infinity :-)
 #ifndef INFINITY
Index: trunk/src/mainwindow.cpp
===================================================================
--- trunk/src/mainwindow.cpp	(revision 53)
+++ trunk/src/mainwindow.cpp	(revision 54)
@@ -30,4 +30,9 @@
 	loadLanguage();
 	setupUi(this);
+#ifndef Q_OS_WINCE
+QStatusBar *statusbar = new QStatusBar(this);
+	statusbar->setObjectName("statusbar");
+	setStatusBar(statusbar);
+#endif // Q_OS_WINCE
 	initDocStyleSheet();
 	solutionText->document()->setDefaultFont(settings->value("Output/Font",QFont(DEF_FONT_FAMILY,DEF_FONT_SIZE)).value<QFont>());
@@ -39,7 +44,7 @@
 	toolBar->setIconSize(QSize(s / 10,s / 10));
 #endif
-#ifndef Q_OS_WINCE
+#ifndef QT_NO_PRINTER
 	printer = new QPrinter(QPrinter::HighResolution);
-#endif // Q_OS_WINCE
+#endif // QT_NO_PRINTER
 	groupSettingsLanguageList = new QActionGroup(this);
 	actionSettingsLanguageEnglish->setData("en");
@@ -58,8 +63,12 @@
 	connect(actionHelpAboutQt,SIGNAL(triggered()),qApp,SLOT(aboutQt()));
 	connect(actionHelpAbout,SIGNAL(triggered()),this,SLOT(actionHelpAboutTriggered()));
-#ifndef Q_OS_WINCE
+#ifndef QT_NO_PRINTER
+	menuFile->insertAction(actionFileExit,actionFilePrintPreview);
+	menuFile->insertAction(actionFileExit,actionFilePrint);
+	menuFile->insertSeparator(actionFileExit);
+	toolBar->insertAction(actionSettingsPreferences,actionFilePrint);
 	connect(actionFilePrintPreview,SIGNAL(triggered()),this,SLOT(actionFilePrintPreviewTriggered()));
 	connect(actionFilePrint,SIGNAL(triggered()),this,SLOT(actionFilePrintTriggered()));
-#endif // Q_OS_WINCE
+#endif // QT_NO_PRINTER
 	connect(buttonSolve,SIGNAL(clicked()),this,SLOT(buttonSolveClicked()));
 	connect(buttonRandom,SIGNAL(clicked()),this,SLOT(buttonRandomClicked()));
@@ -106,8 +115,8 @@
 	if (!enable)
 		output.clear();
-#ifndef Q_OS_WINCE
+#ifndef QT_NO_PRINTER
 	actionFilePrint->setEnabled(enable);
 	actionFilePrintPreview->setEnabled(enable);
-#endif // Q_OS_WINCE
+#endif // QT_NO_PRINTER
 }
 
@@ -206,4 +215,5 @@
 	if (!maybeSave())
 		return;
+	QApplication::setOverrideCursor(QCursor(Qt::WaitCursor));
 	tspmodel->clear();
 	taskView->resizeColumnsToContents();
@@ -214,4 +224,5 @@
 	solutionText->clear();
 	enableSolutionActions(false);
+	QApplication::restoreOverrideCursor();
 }
 
@@ -349,5 +360,5 @@
 }
 
-#ifndef Q_OS_WINCE
+#ifndef QT_NO_PRINTER
 void MainWindow::printPreview(QPrinter *printer)
 {
@@ -372,14 +383,18 @@
 	if (pd.exec() != QDialog::Accepted)
 		return;
+	QApplication::setOverrideCursor(QCursor(Qt::WaitCursor));
 	solutionText->document()->print(printer);
-}
-#endif // Q_OS_WINCE
+	QApplication::restoreOverrideCursor();
+}
+#endif // QT_NO_PRINTER
 
 void MainWindow::buttonRandomClicked()
 {
+	QApplication::setOverrideCursor(QCursor(Qt::WaitCursor));
 	tspmodel->randomize();
 	setWindowModified(true);
 	taskView->resizeColumnsToContents();
 	taskView->resizeRowsToContents();
+	QApplication::restoreOverrideCursor();
 }
 
Index: trunk/src/mainwindow.h
===================================================================
--- trunk/src/mainwindow.h	(revision 53)
+++ trunk/src/mainwindow.h	(revision 54)
@@ -26,9 +26,5 @@
 
 #include "globals.h"
-#ifdef Q_OS_WINCE
-	#include "ui_mainwindow.ce.h"
-#else
-	#include "ui_mainwindow.h"
-#endif // Q_OS_WINCE
+#include "ui_mainwindow.h"
 #include "settingsdialog.h"
 #include "tspsolver.h"
@@ -54,9 +50,9 @@
 	void actionHelpAboutTriggered();
 	void dataChanged();
-#ifndef Q_OS_WINCE
+#ifndef QT_NO_PRINTER
 	void printPreview(QPrinter *);
 	void actionFilePrintPreviewTriggered();
 	void actionFilePrintTriggered();
-#endif // Q_OS_WINCE
+#endif // QT_NO_PRINTER
 	void buttonSolveClicked();
 	void buttonRandomClicked();
@@ -67,7 +63,7 @@
 private:
 	QSettings *settings;
-#ifndef Q_OS_WINCE
+#ifndef QT_NO_PRINTER
 	QPrinter *printer;
-#endif // Q_OS_WINCE
+#endif // QT_NO_PRINTER
 	CTSPModel *tspmodel;
 	QString fileName;
Index: trunk/src/tspsolver.cpp
===================================================================
--- trunk/src/tspsolver.cpp	(revision 53)
+++ trunk/src/tspsolver.cpp	(revision 54)
@@ -39,6 +39,6 @@
 double min = INFINITY;
 	for (int k = 0; k < nCities; k++)
-		if (((k != exc)) && (min > matrix[nRow][k]))
-			min = matrix[nRow][k];
+		if (((k != exc)) && (min > matrix.at(nRow).at(k)))
+			min = matrix.at(nRow).at(k);
 	return min == INFINITY ? 0 : min;
 }
@@ -48,6 +48,6 @@
 double min = INFINITY;
 	for (int k = 0; k < nCities; k++)
-		if ((k != exr) && (min > matrix[k][nCol]))
-			min = matrix[k][nCol];
+		if ((k != exr) && (min > matrix.at(k).at(nCol)))
+			min = matrix.at(k).at(nCol);
 	return min == INFINITY ? 0 : min;
 }
@@ -98,5 +98,5 @@
 		for (int c = 0; c < nCities; c++)
 //			if ((matrix[r][c] == 0) && !forbidden.values(r).contains(c)) {
-			if (matrix[r][c] == 0) {
+			if (matrix.at(r).at(c) == 0) {
 				sum = findMinInRow(r,matrix,c) + findMinInCol(c,matrix,r);
 				if (sum > h) {
Index: trunk/tspsg.pri
===================================================================
--- trunk/tspsg.pri	(revision 53)
+++ trunk/tspsg.pri	(revision 54)
@@ -29,6 +29,5 @@
 
 #Forms
-FORMS += ui/mainwindow.ce.ui \
-	ui/mainwindow.ui \
+FORMS += ui/mainwindow.ui \
 	ui/settingsdialog.ui \
 	ui/settingsdialog.ce.ui
Index: trunk/ui/mainwindow.ui
===================================================================
--- trunk/ui/mainwindow.ui	(revision 53)
+++ trunk/ui/mainwindow.ui	(revision 54)
@@ -7,6 +7,6 @@
     <x>0</x>
     <y>0</y>
-    <width>502</width>
-    <height>407</height>
+    <width>344</width>
+    <height>381</height>
    </rect>
   </property>
@@ -15,5 +15,5 @@
   </property>
   <property name="windowIcon">
-   <iconset>
+   <iconset resource="../resources/tspsg.qrc">
     <normaloff>:/images/icon.png</normaloff>:/images/icon.png</iconset>
   </property>
@@ -33,4 +33,7 @@
       <verstretch>0</verstretch>
      </sizepolicy>
+    </property>
+    <property name="tabPosition">
+     <enum>QTabWidget::North</enum>
     </property>
     <property name="currentIndex">
@@ -268,5 +271,5 @@
      <x>0</x>
      <y>0</y>
-     <width>502</width>
+     <width>344</width>
      <height>22</height>
     </rect>
@@ -296,7 +299,4 @@
     <addaction name="actionFileSave"/>
     <addaction name="menuFileSaveAs"/>
-    <addaction name="separator"/>
-    <addaction name="actionFilePrintPreview"/>
-    <addaction name="actionFilePrint"/>
     <addaction name="separator"/>
     <addaction name="actionFileExit"/>
@@ -342,8 +342,10 @@
    <addaction name="menuHelp"/>
   </widget>
-  <widget class="QStatusBar" name="statusbar"/>
   <widget class="QToolBar" name="toolBar">
    <property name="cursor">
     <cursorShape>ArrowCursor</cursorShape>
+   </property>
+   <property name="windowTitle">
+    <string>Toolbar</string>
    </property>
    <attribute name="toolBarArea">
@@ -357,5 +359,4 @@
    <addaction name="actionFileSave"/>
    <addaction name="separator"/>
-   <addaction name="actionFilePrint"/>
    <addaction name="actionSettingsPreferences"/>
    <addaction name="separator"/>
@@ -405,32 +406,4 @@
    <property name="shortcut">
     <string>Ctrl+P</string>
-   </property>
-  </action>
-  <action name="actionFileSaveSolutionMatrices">
-   <property name="enabled">
-    <bool>false</bool>
-   </property>
-   <property name="text">
-    <string>Solution S&amp;teps</string>
-   </property>
-   <property name="toolTip">
-    <string>Save solution steps</string>
-   </property>
-   <property name="statusTip">
-    <string>Save solution steps only</string>
-   </property>
-  </action>
-  <action name="actionFileSaveSolutionGraph">
-   <property name="enabled">
-    <bool>false</bool>
-   </property>
-   <property name="text">
-    <string>Solution &amp;Graph</string>
-   </property>
-   <property name="toolTip">
-    <string>Save solution graph</string>
-   </property>
-   <property name="statusTip">
-    <string>Save solution graph only</string>
    </property>
   </action>
